
Redmine - Defect #5385
Status filter should show statuses related to project trackers only
2010-04-26 21:22 - Bo Hansen

Status: Closed Start date: 2010-04-26
Priority: Normal Due date:
Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 3.4.0
Resolution: Fixed Affected version: 0.9.3
Description

Using 0.9.3 I define a project to use only an issue tracker without the usual "new, assigned, ..." issue statuses. However when I create
a filter on the issue status field I'm still presented with a list of both my new statuses but also the usual ones.

Thanks for a great project!

Best regards,
Bo

Ruby version              1.8.7 (i686-linux)
RubyGems version          1.3.1
Rack version              1.0
Rails version             2.3.5
Active Record version     2.3.5
Active Resource version   2.3.5
Action Mailer version     2.3.5
Active Support version    2.3.5
Edge Rails revision       unknown
Application root          /home/redmine/redmine-0.9.3
Environment               development
Database adapter          mysql
Database schema version   0

About your Redmine plugins
Stuff To Do Plugin        0.4.0
Redmine Question plugin   0.3.0
Timesheet Plugin          0.6.0

Related issues:
Related to Redmine - Patch # 27772: Issues reports should show only statuses ... Closed
Duplicated by Redmine - Feature # 10643: Only allowes status Closed
Duplicated by Redmine - Feature # 7703: In issue filtering view, only allow i... Closed 2011-02-23
Duplicated by Redmine - Defect # 10647: Other projects statuses show up at pu... Closed
Duplicated by Redmine - Feature # 14217: issues view: only list relevant stat... Closed

Associated revisions
Revision 16575 - 2017-05-27 11:12 - Jean-Philippe Lang

Show statuses of project trackers only (#5385).

Patch by Marius BALTEANU.
Revision 16576 - 2017-05-27 11:13 - Jean-Philippe Lang

Statuses of subprojects should be showed too (#5385).

Revision 16577 - 2017-05-27 11:19 - Jean-Philippe Lang

Show the same trackers and statuses on time entry queries (#5385).

History
#1 - 2010-04-27 23:44 - Thomas Pihl

Could you attach screenshots of Administration - Statuses and the Filter page with statuses dropdown open?

#2 - 2010-04-27 23:46 - Thomas Pihl

Reread our defect report. I don't think this is a defect. If those statuses are defined in the system they should be possible to filter on. This is because
you may save an filter that finds issues in all projects (or all subprojects).

I think this is as it is intended.

#3 - 2010-04-28 08:57 - Bo Hansen
- File redmine_issue-status.jpg added
- File redmine_workflow.jpg added

Still if you are creating a filter while standing in a subproject I think it would be cleaner if only the issue statuses of the available trackers for this
particular project. Especially if you have users only having access to this particular project. Then it would be nice if they are not bothered with a bunch
of issue statuses they never use.
I understand about the global filters. In that case it should definitely show all issue statuses.

#4 - 2010-04-28 10:16 - Thomas Pihl

May i suggest a change to Feature Request on this one, since i agree that it would be nice.

#5 - 2010-04-30 11:31 - Bo Hansen
- File issue_statuses_filter_fix.diff added

Turned out that Query.rb already selects trackers available per project and subprojects. The attached patch utilizes this information and thus the
global filtering issue is also taken care of.

#6 - 2010-09-16 08:40 - Bob Bottle

Are there any plans to include this patch in a future release?
#7 - 2015-10-09 12:10 - Olivier Houdas
- File 4385_issue_statuses_filter_fix_RM_3.1.1.diff added

It would be nice to include this fix in Redmine 3.1.2 or 3.2.

Attached is a patch (slightly different, but works) for Redmine 3.x, as the code of the previously attached patch became a bit old, and that part was
moved from query.rb to issue_query.rb in more recent versions of Redmine.

#8 - 2015-10-10 07:19 - Go MAEDA
- Target version set to Candidate for next major release

Thank Olivier Houdas for updating the patch.

attachment:4385_issue_statuses_filter_fix_RM_3.1.1.diff looks good to me on Redmine 3.1.1.devel.14669. Statuses used in the current project and
subprojects are shown.

#9 - 2015-10-10 07:32 - Go MAEDA
- Related to Feature #7703: In issue filtering view, only allow issue status selections which are available in the current project added

#10 - 2015-10-10 07:33 - Go MAEDA
- Related to deleted (Feature #7703: In issue filtering view, only allow issue status selections which are available in the current project)

#11 - 2015-10-10 07:34 - Go MAEDA
- Duplicated by Feature #7703: In issue filtering view, only allow issue status selections which are available in the current project added

#12 - 2015-10-10 13:31 - Sebastian Paluch

+10

any chance to plan this sooner than next major?

#13 - 2015-10-24 09:28 - Toshi MARUYAMA
- Duplicated by Defect #10647: Other projects statuses show up at pull down list on issue filtering added

#14 - 2017-04-18 01:49 - Marius BALTEANU
- File 5385_restrict_issues_statuses_in_query.patch added

Here is an updated patch that restricts the statuses in the issue filter only to the statuses used by the current project and its subprojects. For the global
issues page, all statuses are listed in the filter.
I think we should change the current behaviour (which lists all the statuses regardless the project) for the following reasons:
    1. consistency: with tracker and custom fields behaviour (#25501#note-4) 
    2. privacy: for example, in our instance, we have some internal projects with multiple statuses (not related to our development workflow) that we
don't want to be visible for our customers (they don't have access to the respective projects) each time when they access their projects.

As a technical note, I tried to use the patch made by  Olivier Houdas, but it doesn't work too well because some issues statuses from
WorkflowTransition are not returned by the query. I can add some examples, if it is necessary.
#15 - 2017-04-19 09:49 - Go MAEDA
- Target version changed from Candidate for next major release to 3.4.0

Marius BALTEANU, thank you for improving the patch. It looks good to me. Passed all tests.

Marius BALTEANU wrote:
I think we should change the current behaviour (which lists all the statuses regardless the project) for the following reasons:    1. consistency: with
tracker and custom fields behaviour (#25501#note-4) 
    2. privacy: for example, in our instance, we have some internal projects with multiple statuses (not related to our development workflow) that we
don't want to be visible for our customers (they don't have access to the respective projects).

Indeed.

Setting target version to 3.4.0.

#16 - 2017-05-27 11:20 - Jean-Philippe Lang
- Subject changed from All issue statuses shown when creating status filter to Status filter should show statuses related to project trackers only
- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang
- Resolution set to Fixed

Patch applied, thanks. I've also updated the time entry query in order to show the same trackers and statuses.

#17 - 2017-09-05 17:26 - Marius BALTEANU
- Duplicated by Feature #14217: issues view: only list relevant status in filter drop down added

#18 - 2017-12-10 14:13 - Marius BALTEANU
- Related to Patch #27772: Issues reports should show only statuses used by the project added
issue_statuses_filter_fix.diff 1.34 KB 2010-04-30 Bo Hansen
4385_issue_statuses_filter_fix_RM_3.1.1.diff 718 Bytes 2015-10-09 Olivier Houdas
5385_restrict_issues_statuses_in_query.patch 5.29 KB 2017-04-17 Marius BALTEANU

2022-11-28 4/4


